<?php
/**
 * File gcalPKHG_class.php
 *
 * @version $Id$
 * @copyright 2007 PKHG
 * a calendar class for PmWiki
 */

/**
 * $a and $b are arrays with first element a date
 */

class PKHGCalender {
    var $myDBG = null;
    var $error = "";
    var $params = null;
    var $pageNames = null;
    var $nrOfPages = 0;
    var $callingPage = "";
    var $allDataOfPages = array();
    var $dateFormats = null;
    var $availableLanguages = array("nl", "de", "en");
    var $language = 'nl'; //default language
    var $lang = null;
    var $startDate = null;
    var $endDate = null;
    var $emptyToo = "1"; //show all days
    var $month = 1;
    var $nrOfMonth = 1;
    var $addYear = 0;
    var $merge = false;
    /**
     * Class constructor initializes  a debugging facility and ... the parameters of the markup
     */
    function PKHGCalender($data = null)
    {
        $this->myDBG = new PKHGsDebug("calendar_DBG");
        preg_match('!^' . preg_quote($_SERVER['SCRIPT_NAME'], '!') . '/?([^?]*)!', $_SERVER['REQUEST_URI'], $match);
        $pagename = urldecode($match[1]);
        $this->callingPage = $pagename;
        //$this->myDBG->msgAndMaybeStop(true,"L49 $pagename","magenta",$_REQUEST);
        if ($data) {
            $this->splitParameters_PageNames($data);
        }
	if (isset($this->params['merge'])) $this->merge = $this->params['merge'];
	if (isset($_GET['merge'])) $this->merge = $_GET['merge'];
        // $this->myDBG->msgAndMaybeStop(false,"stop","green",$this->params);
        if (isset($this->params['month'])) $month = 0 + $this->params['month'];
        if (isset($_GET['month'])) {
            $month = 0 + $_GET['month'];
            // $this->myDBG->msgAndMaybeStop(true,"L58 $month","red",$_GET);
        }
        if ($month < 1 || $month > 12) {
            $this->error = "<h2 style=\"color:red\">wrong month given, :$month: not possible</h2>";
            $tmp = getdate();
            $this->month = $tmp['mon'];
        } else {
            $this->month = $month;
        }
	$nrOfMonth = $this->nrOfMonth;
        if (isset($this->params['nrOfMonth'])){
	  $nrOfMonth = round(0+$this->params['nrOfMonth']);
	}
	if ($nrOfMonth < 1 || $nrOfMonth > 6){
	  $this->nrOfMonth = 1;
	} else {
	  $this->nrOfMonth = $nrOfMonth;
	}
	//$this->myDBG->msgAndMaybeStop(false,"L78 nr of month = $nrOfMonth","blue");
        if (isset($this->params['emptyToo'])) $this->emptyToo = $this->params['emptyToo'];
        if (isset($_GET['emptyToo'])) $this->emptyToo = $_GET['emptyToo'];
        // $this->emptyToo default is "true": show all days;
        // $this->myDBG->msgAndMaybeStop(true,"L58 $this->emptyToo","red",$_GET);
        if (isset($this->params['language'])) $this->language = $this->params['language'];
        if (isset($_GET['language'])) {
            $this->language = strtolower($_GET['language']);
        }
        if (!in_array($this->language, $this->availableLanguages)) {
            $this->language = 'en';
        }
        $tmp = "./cookbook/gcalPKHG/lang/" . $this->language . "/langArray.php";
        include_once($tmp); //contains the function setLanguageParamete
        // $this->setLanguageParameter();
        $this->lang = setLanguageParameter();
        // dates recognized:
        // match dates in american-style, i.e. 12/31/2006
        $this->dateFormats['mdy'] = '([0-9]{1,2})\/([0-9]{1,2})\/([0-9]{4}|[0-9]{2}|)';
        // match european styled dates. i.e. 31.12.2006
        $this->dateFormats['dmy'] = '([0-9]{1,2})\.([0-9]{1,2})\.([0-9]{4}|[0-9]{2}|)';
        // match isodates. i.e. 2006-12-31 or 06-12-31
        $this->dateFormats['ymd'] = '([0-9]{2}|[0-9]{4}|)\-([0-9]{1,2})\-([0-9]{1,2})';
    }

    function gcalOutput ($par=null)
    {
        // $tmp = getdate();
        $month = $this->month;
	$nrOfMonth = $this->nrOfMonth;
        // if (isset($this->params['month'])) $month=$this->params['month'];
        // if (isset($_GET['month'])) $month = $_GET['month'];
        // $emptyToo=0;
        // if (isset($this->params['emptyToo'])) $month=$this->params['emptyToo'];
        // if (isset($_GET['emptyToo'])) $month = $_GET['emptyToo'];
        foreach($this->pageNames as $page) {
            $this->setAllPagedatesInCategories($page);
        }
        $info = $this->mergeInfo($month);
	$calendar = "";
	$calendar .= $this->kalenderStart();
	$calendar .= $this->kalenderCaption();
	$calendar .= $this->kalenderLinkrow();
	$calendar .= $this->kalenderBody($info);
	// $this->myDBG->msgAndMaybeStop(false,"L138 $month $nrOfMonth","red");
        $overflow = 0; 
	for ($i = 1 ; $i < $nrOfMonth;$i++){
	  $tmp = $month+$i;
	  if ($tmp > 12 ) {
            $overflow = 1; 	    
	    $tmp  -=12;
	  }
           $info2 = $this->mergeInfo($tmp);
	   $calendar .= $this->kalenderNextMonth($tmp,$overflow);
	   $calendar .= $this->kalenderBody($info2);
	   //	   $this->myDBG->msgAndMaybeStop(false,"L138 $month $this->nrOfMonth","red");
	}
	//$this->myDBG->msgAndMaybeStop(true,"L140 $month","red");
	$calendar .= $this->kalenderEnd();
	return $calendar;
    }

    /** To sort an array with array elements
     */
    function cmp_s1($a, $b)
    {
      $tmp1 = $a[0];
      $tmp2 = $b[0];
      $result = 0 ;
      if ($tmp1 != $tmp2) {
	$result =($tmp1 < $tmp2) ? -1 : 1;
      }
      return $result;
      /*
      if ($tmp1 == $tmp2) {
        return 0;
      }
      return ($tmp1 < $tmp2) ? -1 : 1;
      */
    }

    /**
     * The result is an array containing sorted events (increasing with respect to date) 
     * each element contains one ore more events
     * info Chapter Wikipage
     */

    function mergeInfo($month)
    {
        $result = null;
        $dat = array();
        $nrOfPages = $this->nrOfPages;
        for ($i = 0 ; $i < $nrOfPages; $i++) {
            $tmp = $this->selectInfoForMonth($this->pageNames[$i], $month);
            $dat = array_merge($dat, $tmp);
        }
        // $this->myDBG->msgAndMaybeStop(true,"L130","blue",$dat);
	usort($dat, array($this,"cmp_s1"));
	/**
	 * $dat is an array of arrays. each element in the array contains 4 parameters:
	 * date (Unixnumber) infoline chaptertitel fromWikiPage
	 */
        //$this->myDBG->msgAndMaybeStop(true,"L133 ","blue",$dat);
        $info = array();
        // while ($i < $nrOfPages){
        // $tmp = $dat[$i];
        while ($dat) {
	    $tmp = array_shift($dat);//makes $dat decrease to null, stops while
            $date = array_shift($tmp);
            // echo "$i $date<br>";
            // $this->myDBG->msgAndMaybeStop(true,"L143 $date","blue",$tmp);
            $counter = 0;
            $info[$date] = array();
            $info[$date][$counter] = $tmp;
            // $this->myDBG->msgAndMaybeStop(true,"L148 $date","blue",$info);
            $counter++;
            if ($dat) {
                $check = $dat[0][0] == $date;
            } else {
                $check = false;
            }
	    while ($check) {
                $tmp = array_shift($dat);
                array_shift($tmp);
                $info[$date][$counter] = $tmp;
                // $this->myDBG->msgAndMaybeStop(true,"L160 $date","blue",$info);
                $counter++;
                if ($dat) {
                    $check = $dat[0][0] == $date;
                } else {
                    $check = false;
                }
            }
        }
        //$this->myDBG->msgAndMaybeStop(true,"L203","blue",$info);
        return $info;
    }

    function kalenderStart(){
      $tableStart = "\n<table class=\"gCal_table\">\n";        
      return $tableStart;
    }

    function kalenderCaption()
    {
        $next = 1 + $this->month;
        $nextMonth = $next > 12?1:$next;
        $previous = -1 + $this->month;
        $previousMonth = $previous < 1?12:$previous;    
        $takeToo = '';
        $emptyToo = $this->emptyToo;
	//if no smart pages are used ...
        if (isset($_GET['n'])) {
	    $takeToo = "n=" . $_GET['n'] ;
	}
        $toggle = '';
        if (isset($_GET['toggleEmpty'])) {
            $emptyToo = !$emptyToo;
        } else {
            $toggle = "&toggleEmpty=1";
        }
        if (strlen($takeToo > 2)) {
            $toggle = "$takeToo&" . $toggle;
        }

        // $this->myDBG->msgAndMaybeStop(true,"L226 nu $toggle ","black",$_GET);
        $toggle .= "&month=$this->month";
	$tableCaption = "<caption><table border=\"2\" width=\"100%\"  summary=\"next and previous\">";
	$tableCaption .= "<tr><td><a href=\"?{$takeToo}&month=$previousMonth\">&lt;&lt;</a></td>";
	$tableCaption .= "<td><a href=\"?{$takeToo}$toggle\">toggle</a></td>";
	$tableCaption .= "<td> <a href=\"?{$takeToo}&month=$nextMonth\">&gt;&gt;</a></td></tr>";
	/* does not work with CSS?
	if (strlen($this->error)>-1){
	    $tableCaption .= "<tr><td colspan=\"3\">$this->error</td><tr>";
	}
	//*/
	$tableCaption .="</table></caption>";
	return $tableCaption; 
    }

    function kalenderLinkrow(){
        $from = $this->startDate;
        $dataLink = $this->makeLinkrow();
	$tableHead = "<thead class =\"CP_LINK_HEAD\">$dataLink\n";
        // $this->myDBG->msgAndMaybeStop(true,"L191 $test","black");//,$info);
        $monthInternational = $this->lang["CP_month_" . (0 + date("m", $from))];
        $nrOfPages = $this->nrOfPages;
        $nrOfColums = 1 + $nrOfPages;
	//TODO $year 
	$year = date('Y');
        $tableHead .= "<tr><td class=\"CP_MONTH gCal_wd\" colspan=\"$nrOfColums\">$monthInternational $year</td></tr>\n";
        $tableHead .= "</thead>";
	return $tableHead;
    }

    function kalenderNextMonth($month,$nyear=0){
        
        $monthInternational = $this->lang["CP_month_$month"];
        $nrOfPages = $this->nrOfPages;
        $nrOfColums = 1 + $nrOfPages;
	//TODO $year 
	$year = $nyear+date('Y');
	$tableNextMonth = "";//"<tr><td class=\"CP_MONTH gCal_wd\" colspan=\"$nrOfColums\">&nbsp;</td></tr>\n";
        $tableNextMonth .= "<tr><td class=\"CP_MONTH gCal_wd\" colspan=\"$nrOfColums\">$monthInternational $year</td></tr>\n";
	return $tableNextMonth;

    }

    function kalenderBody(&$info){
        $emptyToo = $this->emptyToo;
        $toggle = '';
        if (isset($_GET['toggleEmpty'])) {
            $emptyToo = !$emptyToo;
        } 

        $lang = $this->lang;
        $today = $this->todayUnixNumber();
        $from = $this->startDate;
        $upto = $this->endDate;
        $tbodyStart = "<tbody>\n";
        $tableBody = "";
        $emptyRow = "";
	$nrOfPages = $this->nrOfPages;
        for ($i = 0 ; $i < $nrOfPages ;$i++) {
            $emptyRow .= "<td CSS>&nbsp;</td>";
        }
	$nothing = true;
        // $dff = $upto - $from;
        $row = null;
        // $this->myDBG->msgAndMaybeStop(false,"L238","black",$info);
        $dateKeys = array();
        if ($info) {
            $dateKeys = array_keys($info);
            $row = array_shift($info);
            // $this->myDBG->msgAndMaybeStop(false,"L297","black",$dateKeys);
            $date = array_shift($dateKeys);
            // $this->myDBG->msgAndMaybeStop(false,"L245 $date","black",$row);
            $nothing = false;
        }
        // $this->myDBG->msgAndMaybeStop(false,"L248","black",$info);
        // loop over all days from upto
        $counter = -1 + date('d', $from);
        // $from = strtotime("+10 days",$from); not yet possible!
        $counter = -1 + date('d', $from);
        for ($i = $from;$i <= $upto;$i = strtotime ("+1 days", $i)) {
            // $this->myDBG->msgAndMaybeStop(false,"254 in for","black",$row);
            $todayClass = "";
            if ($i == $today) {
	        $todayClass = "gCal_today gCal_todayFrame";
		$success = true;
	    }
            $counter++;
            $dayNr = "$counter<br /><span class=\"gCal_mv_weekday\">" . $lang["CP_weekday_" . date("w", $i)] . "</span>";
            $wDay = date("w", $i);
            // $tmp = "<tr class=\"CP_wd_$wDay\"><td class=\"CP_wd_$wDay $todayClass CP_mv_day\">$dayNr</td>";
            if ($todayClass == '') {
                $tmp = "<tr><td class=\"gCal_wd gCal_wd_datecell gCal_wd_$wDay\" ><span class='gCal_mv_day' >$dayNr</span></td>";
            } else {
                $tmp = "<tr><td class=\"gCal_wd gCal_wd_datecell gCal_wd_$wDay $todayClass\"  ><span class='gCal_mv_day'>$dayNr</span></td>";
            }
            // echo $counter."<br />";
            if ($todayClass == '') {
                $CSSClass = "class=\"gCal_wd  gCal_wd_$wDay\"";
            } else {
                $CSSClass = "class=\"gCal_wd  gCal_wd_$wDay gCal_todayFrame\"";
            }
            if ($date == $i) {
                $success = true;
                $nothing = false;
                $tmp .= $this->makeDateLine($row, $CSSClass);

                if ($info) {
                    $row = array_shift($info);
                    // $this->myDBG->msgAndMaybeStop(false,"L179","black",$dateKeys);
                    $date = array_shift($dateKeys);
                }
            } else {
                $tmp .= str_replace("CSS", $CSSClass, $emptyRow); //"<td> </td><td> </td>";
            }
            // $this->myDBG->msgAndMaybeStop(false,"L227 nu $emptyToo ","black");//,$this->params);
            if ($success) {
                $tableBody .= $tmp . "</tr>\n";
                $success = false;
            } else if (($emptyToo != "0")) {
                $tableBody .= $tmp . "</tr>\n";
            }
        }
        if ($nothing) $tableBody .= "<tr><td colspan=\"$nrOfColums\">  niets, nichts, nothing, rien, ...</td></tr>";

	return $tableBody;
    }

    function kalenderEnd(){
      $tableEnd = "\n<tfoot></tfoot></table>\n";
      return $tableEnd;
    }

    function makeDateLine(&$row, $CSSClass)
    {
        $result = null;
        $pages = $this->pageNames;
	$nrOfPages = count($pages);
        foreach($pages as $page) {
            $result[$page] = array();
        }
        //$this->myDBG->msgAndMaybeStop(true,"L248","green",$result);
        foreach($row as $oneEntry) {
            $tmp = array_pop($oneEntry);
            $result[$tmp][] = $oneEntry;
        }
	$merge = $this->merge;
	//$this->myDBG->msgAndMaybeStop(false,"L372","green",$result);
	if ($merge){
	  $tmp = "<td $CSSClass colspan=\"$nrOfPages\">&nbsp;";
	} else {
        $tmp = "";
	}
        foreach($pages as $page) {
            $col = $result[$page];
            //$this->myDBG->msgAndMaybeStop(false,"L237","green",$col);
            $nrCol = count($col);
	    if (!$merge){
	      $c[$page] = "<td $CSSClass>&nbsp;";
	    }
            for ($i = 0; $i < $nrCol;$i++) {
                $more = "";
                // $this->myDBG->msgAndMaybeStop(false,"L289 :$ttt: ","red",$col);
                $ddd = array_shift($col);
                if ($i > 0) {
                    $more = "<br />";
                }
                // if (preg_match("/vacantie/",$ddd[0])){
                // $this->myDBG->msgAndMaybeStop(false,"L294 :$ttt: ddd1= $ddd[1]","red");//,$col);
                $ddd[0] = MarkupToHTML(null, $ddd[0], null);
                /*
              if (preg_match("/computer/i",$ddd[0])){
		        $this->myDBG->msgAndMaybeStop(false,"L294 :$ttt: ddd0=$ddd[0]","red");//,$col);
	      }
	      //*/
                $ddd0 = substr($ddd[0], 5);
                $ddd0 = substr($ddd0, 0, strlen($ddd0)-7);
                // $this->myDBG->msgAndMaybeStop(true,"L297 ddd0 = $ddd0 ddd1= $ddd[1]","red");//,$col);
                // }
		if ($merge){
		  $tmp .= "$more<div class=\"gCal_cat_$ddd[1] gCal_event\">$ddd0 </div>";} else {
                $c[$page] .= "$more<div class=\"gCal_cat_$ddd[1] gCal_event\">$ddd0 </div>";
		}
            }
	    if (!$merge){
            $tmp .= $c[$page];
	    }
            // $this->myDBG->msgAndMaybeStop(false,"L248 $nrCol");
        }
        // $this->myDBG->msgAndMaybeStop(true,"L248","green",$result);
        return($tmp . "</td>");
    }



    /**
     * $from an array of ONE data page
     * month a number 1 to 12 (Jan to Dec)
     */
    function selectInfoForMonth($pageName, $month)
    {
        $year = date('Y');
        $startDate = mktime(0, 0, 0, $month, 1, $year);
        $this->startDate = $startDate;
        $endDate = strtotime("+1 month -1 day", $startDate);
        $this->endDate = $endDate;
        // $keys = array_keys($fromArray);
        $result = array($pageName); //the results
        $fromArray = $this->allDataOfPages["$pageName"];

        $sortedInfo = array();

        $nrSections = count($fromArray);
        $dataSelected = array();
        foreach ($fromArray as $tmp) {
            // for ($i=0;$i<$nrSections;$i++){
            // $tmp = $fromArray[$i];//all dates of a section (from !! ...)
            // $this->myDBG->msgAndMaybeStop(false,"L327 i = $i $nrSections test ","black",$fromArray);
            $nrTmp = count($tmp);
            if ($nrTmp < 2) continue;
            $sectionName = $tmp[0];
            $ok = false; //not yet any suitable dates  found
            $collect = array();
            for ($j = 1;$j < $nrTmp;$j++) {
                $tmpEntry = $tmp[$j];
                $tmpDate = $tmpEntry[0];
                if ($tmpDate >= $startDate && $tmpDate <= $endDate) {
                    // $collect[]=array(date("d m Y",$tmpEntry[0]),$tmpEntry[1]);
                    $collect[] = $tmpEntry;
                    $sortedInfo[] = array($tmpEntry[0], $tmpEntry[1], strtoupper($sectionName), $pageName);
                    $ok = true;
                }
            }
            if ($ok) {
                // for all sections, if success in search
                $result[] = array($sectionName, $collect);
            }
        }
        // $this->myDBG->msgAndMaybeStop(true,"L139 nu","green",$sortedInfo);
        usort($sortedInfo, array($this,"cmp_s1"));
        // $this->myDBG->msgAndMaybeStop(true,"L141 nu","green",$sortedInfo);
        $result = $sortedInfo;
        // $this->myDBG->msgAndMaybeStop(false,"L85 nu","green",$result);
        return $result;
    }

    /**
     * setAllPagedatesInCategories sets an array for each categorie.
     * the category is the key containing an array for each found date
     * converted into an dateinteger for date
     * calculations and its comment
     */
    function setAllPagedatesInCategories($pageName)
    {
        $result = array();
        // $result = "<span style=\"color:red\">no data found</span>";// in case of error
        $totalPage = ReadPage($pageName);
        $allLines = preg_replace("/!!(?!!)/", "~pkhg~", $totalPage['text']);
        // $this->myDBG->msgAndMaybeStop(true,"L369 in class $allLines","brown", false,$allLines);
        $paragraphs = preg_split('/~pkhg~/', $allLines);
        $nrParagraphs = count($paragraphs);
        $yearToday = date('Y');
        // $this->myDBG->msgAndMaybeStop(true,"L373 in class $nrParagraphs","brown",$paragraphs);
        // First element is disregarded
        for($i = 1 ; $i < $nrParagraphs; $i++) { // $i counts the categories
            // we depend on \n as discrimination or lines
            $headAndTails = explode("\n", $paragraphs[$i]);
            $nrHeadAndTails = count($headAndTails);
            // $this->myDBG->msgAndMaybeStop(false,"L373 in class $nrHeadAndTails","brown",$headAndTails);
            if ($nrHeadAndTails < 2) {
                continue; //empty categorie
            } else {
                $theDataFrom = array();
                $theDataFrom[0] = $headAndTails[0];
                $ok = false;
                // for each possible dataline
                $count = 0;
                for ($j = 1; $j < $nrHeadAndTails ;$j++) {
                    $tmp = $headAndTails[$j];

                    /*
		if (preg_match("/anerbr/i",$tmp)){
		  $date = $this->fetch_date($tmp,$yearToday); //yyyymmddPattern
		  $this->myDBG->msgAndMaybeStop(false,"L374  $tmp date =$date+","brown");
		}
		//*/
                    // *
                    // TODO what is the default day?
                    // $date = $this->fetch_date($tmp,$yearToday); //yyyymmddPattern
                    $date = $this->fetch_date($tmp, $this->todayUnixNumber()); //yyyymmddPattern
                    if (!$date) continue;
                    // $this->myDBG->msgAndMaybeStop(false,"L403 in class $tmp","brown");//,$headAndTails);
                    $ok = true;
                    $count++;
                    $dag = substr($date, 6, 2);
                    $month = substr($date, 4, 2);
                    $pattern = substr($date, 8);
                    $thisYearsYear = mktime(0, 0, 0, $month, $dag, $yearToday);
                    $tmp = preg_replace("#^$pattern#", "", $tmp);
                    $tmp = preg_replace('/\\\\\\\\$/', '', $tmp);
                    $theDataFrom[$count] = array($thisYearsYear, $tmp);
                }
                if ($ok) {
                    $result[$i-1] = $theDataFrom; //array should start at 0!
                }
            }
        }
        $this->allDataOfPages["$pageName"] = $result;
        // $this->myDBG->msgAndMaybeStop(true,"L406 $yearToday","brown",$this->allDataOfPages);
    }

    /**
     * Splitparams returns either null or an arrray containig the key 'pages'
     */

    function splitParameters_PageNames($line = null)
    {
        $ok = false;
        $treffer = array();
        // preg_match("/pages=\((\w+.\w+)(;\w+.\w+)*\)/",$line,$treffer);
        // $this->myDBG->msgAndMaybeStop(false,"L39 line = $line ","",$treffer);
        if (preg_match("/^pages=\((\w+.\w+)(;\w+.\w+)*\)/", $line, $treffer)) {
            $tmp = substr($treffer[0], 7, -1);
            // $this->myDBG->msgAndMaybeStop(true,"L220 $tmp ");
            $this->pageNames = explode(";", $tmp);
            $this->nrOfPages = count($this->pageNames);

            $line = preg_replace("/$treffer[0]\s*/", "", $line);
            // $this->params = explode(" ",$line);
            $tmp = explode(" ", $line);
            $nrTmp = count($tmp);
            $params = array();
            for ($i = 0; $i < $nrTmp;$i++) {
                list($key, $value) = explode("=", $tmp[$i]);
                $params[$key] = $value;
            }
            $this->params = $params;
            $this->error = "<span>PKHG: all OK!</span>";
            $ok = true;
        } else {
            $this->error = "<h2 style='color:red'>no correct calendar input given </h2>"; // in case of error
        }
        return $ok;
    }

    /**
     * Precondition
     * setPagenames
     */
    function setPageNames()
    {
        $input = $this->params;
        if (!$input) {
            $this->error = "<h2 style='color:red'>no correct input page(s) given given </h2>"; // in case of error
            $this->pageNames = null;
        } else {
            // an element with "pages=(.
        }
    }

    /**
     * fetch_date($text,$default_date)
     * returns date at the beginning of the text.
     */
    function fetch_date($text, $default_date)
    {
        $dateFormats = $this->dateFormats;
        // $this->myDBG->msgAndMaybeStop(true,"L461","black",$dateFormats);
        if ($text == "") return;
        // '#^'            --> # string has to start with the pattern.
        // '(?=($|\D))#'   --> # look-ahead => any non-digit or end-of-string terminates pattern
        if (preg_match('#^' . $dateFormats['dmy'] . '(?=($|\D))#', $text, $match)) {
            $d = $match[1];
            $m = $match[2];
            $y = $match[3];
        } elseif (preg_match('#^' . $dateFormats['mdy'] . '(?=($|\D))#', $text, $match)) {
            $d = $match[2];
            $m = $match[1];
            $y = $match[3];
        } elseif (preg_match('#^' . $dateFormats['ymd'] . '(?=($|\D))#', $text, $match)) {
            $d = $match[3];
            $m = $match[2];
            $y = $match[1];
        } else {
            return null;
        }

        if (strlen($d) == 1) $d = '0' . $d;
        if (strlen($m) == 1) $m = '0' . $m;
        if (strlen($y) == 0) $y = date('Y', $default_date);
        if (strlen($y) == 2) $y = '20' . $y;
        // $text=trim(substr($text,strlen($match[0])));
        return $y . $m . $d . $match[0]; // return format yyyymmdd
    }

    function makeLinkrow()
    {
      global $PubDirUrl;
        $result = "<tr><td class=\"gCal_wd\" width=\"10%\"><img src=\"$PubDirUrl/images/date.gif\">  </td>";
        $pageNames = $this->pageNames;
        $nrOfPages = $this->nrOfPages;
        $size = 90 / $nrOfPages;
        $widthpar = "width=\"$size%\" ";
        for ($i = 0 ; $i < $nrOfPages ;$i++) {
            $result .= "<td $widthpar class=\"CP_link gCal_wd \"><a href=\"./pmwiki.php?n=$pageNames[$i]\">$pageNames[$i]</a></td>\n";
        }
        return ($result . "</tr>\n");
    }

    function todayUnixNumber()
    {
        $today = getdate();
        $day = $today["mday"];
        $year = $today["year"];
        $month = $today["mon"];
        $result = mktime(0, 0, 0, $month, $day, $year);
        return $result;
    }
}
